       include 'inout.fi'
       include 'flib.fi'
       
       INTERFACE TO SUBROUTINE sound(tone, duration)
       integer tone, duration
       end

       call sound(1088, 500)

       END !---------------------------


C--------------------------------------------------------------
C SOUND Subroutine               
C
C  Sound is essentially the same as BEEPQQ.  
C  This is just a demonstration of using INQQ and OUTQQ functions.
C
C  tone is in hertz
C  duration is in number of mSec.
C
C Date: 5/93
C--------------------------------------------------------------

       subroutine sound(tone, duration)
       integer tone, duration
       integer port, value
       include 'flib.fd'
                         
                               
       tone = iand(tone, #0000FFFF) ! Just make sure we're in range
                                    
       port = #43                   ! Initialize channel 2 of timer chip
       value = #B6
       call OUTQQ(port, value)

       tone = 1193180/tone          ! Divide clock frequency by desired hertz

       port = #42                   ! OUTQQut low byte
       value = iand(tone, #000000FF)
       call OUTQQ(port, value)
       
       port = #42                   ! OUTQQut high byte
       value = ishft(tone, -8)
       call OUTQQ(port, value)
       
       port = #61
       value = INQQ(port)             ! Get value from port 61h

       value = ior(value, #03)      ! Set 1st 2 bytes high 
       call OUTQQ(port, value)       ! turn on speaker

       call sleepqq(duration)       ! wait
       
       value = INQQ(port)

       value = ieor(value, #03)     ! kill bits 1 & 0 ...
       call OUTQQ(port, value)       ! ...turns it off

       ! restore registers

       END

